Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# SlamSelfLocatorSample Class Reference

The class represents a sample. More...

`#include <SlamSelfLocatorSample.h>`

Inheritance diagram for SlamSelfLocatorSample:

[legend]
Collaboration diagram for SlamSelfLocatorSample:

[legend]
List of all members.

## Public Types
enum | { UNINITIALIZED_PROBABILITY = 2, NO_PERCEPT_PROBABILITY = 3, PERCEPT_TTL_MS = 2000 }
enum | PerceptType { xFieldLine, yFieldLine, flag, yellowGoal, skyblueGoal, lineCrossing, numberOfPerceptTypes }
## Public Member Functions
| SlamSelfLocatorSample ()
| Constructor.
| SlamSelfLocatorSample (const Pose2D &pose)
| Constructor.
double | getProbability () const
void | updateProbability ()
void | updateProbability (const double *average)
void | setPerceptProbability (SlamSelfLocatorSample::PerceptType type, double value)
| sets the probability for a percept.
bool | isValid () const
## Public Attributes
Pose2D | camera
| Temporary representing the pose of the camera.
double | perceptProbabilities [numberOfPerceptTypes]
| a probability for each percept-type recognized
long | perceptTimestamps [numberOfPerceptTypes]
SlamSelfLocatorSample * | next
| The next sample in the cell cube.
## Static Public Attributes
double | paramProbUpLimit
double | paramProbDownLimit
double | paramProbDelay

## Detailed Description

The class represents a sample.

Definition at line 16 of file SlamSelfLocatorSample.h.

## Member Enumeration Documentation

anonymous enum

  | Enumeration values:
  UNINITIALIZED_PROBABILITY |
  NO_PERCEPT_PROBABILITY |
  PERCEPT_TTL_MS |
Definition at line 20 of file SlamSelfLocatorSample.h.

enum SlamSelfLocatorSample::PerceptType

  | Enumeration values:
  xFieldLine |
  yFieldLine |
  flag |
  yellowGoal |
  skyblueGoal |
  lineCrossing |
  numberOfPerceptTypes | the number of percept types
Definition at line 32 of file SlamSelfLocatorSample.h.

## Constructor & Destructor Documentation

SlamSelfLocatorSample::SlamSelfLocatorSample | ( |  | ) |

| Constructor. Definition at line 12 of file SlamSelfLocatorSample.cpp.

SlamSelfLocatorSample::SlamSelfLocatorSample | ( | const Pose2D & | pose | ) |

  | Constructor. Parameters:
  pose | The pose of the sample.
Definition at line 23 of file SlamSelfLocatorSample.cpp. References SystemCall::getCurrentSystemTime().

Here is the call graph for this function:

## Member Function Documentation

double SlamSelfLocatorSample::getProbability | ( |  | ) | const`[inline]`

| Definition at line 59 of file SlamSelfLocatorSample.h. Referenced by SlamSelfLocator::calcPoseFromSubCube(), and SlamSelfLocator::resample().

void SlamSelfLocatorSample::updateProbability | ( |  | ) |

| Definition at line 40 of file SlamSelfLocatorSample.cpp.

void SlamSelfLocatorSample::updateProbability | ( | const double * | average | ) |

| Definition at line 62 of file SlamSelfLocatorSample.cpp. References max, paramProbDelay, and paramProbUpLimit.

void SlamSelfLocatorSample::setPerceptProbability | ( | SlamSelfLocatorSample::PerceptType | type,
|  | double | value
| ) |

  | sets the probability for a percept. replaces setProbability in GT04SL limits change of probability to +paramProbUpLimit and -paramProbDownLimit differs from gt code by strange part dependent on goal type Parameters:
  type | of the percept the probability is updated for
Returns: value the probability for the percept Definition at line 93 of file SlamSelfLocatorSample.cpp. References paramProbDownLimit, and paramProbUpLimit. Referenced by SlamSelfLocator::updateByCenterCircle(), SlamSelfLocator::updateByCrossing(), SlamSelfLocator::updateByFlag(), SlamSelfLocator::updateByGoalPost(), and SlamSelfLocator::updateByPoint().

bool SlamSelfLocatorSample::isValid | ( |  | ) | const`[inline]`

| Definition at line 83 of file SlamSelfLocatorSample.h. Referenced by SlamSelfLocator::calcPose(), and SlamSelfLocator::calcPoseFromSubCube().

## Member Data Documentation

double SlamSelfLocatorSample::paramProbUpLimit`[static]`

| Initial value:
     0.01
           SlamSelfLocatorSample::paramProbDownLimit = 0.005
           SlamSelfLocatorSample::paramProbDelay = 3
Definition at line 8 of file SlamSelfLocatorSample.cpp. Referenced by setPerceptProbability(), and updateProbability().

double SlamSelfLocatorSample::paramProbDownLimit`[static]`

| Definition at line 26 of file SlamSelfLocatorSample.h. Referenced by setPerceptProbability().

double SlamSelfLocatorSample::paramProbDelay`[static]`

| Definition at line 26 of file SlamSelfLocatorSample.h. Referenced by updateProbability().

Pose2D SlamSelfLocatorSample::camera

| Temporary representing the pose of the camera. Definition at line 43 of file SlamSelfLocatorSample.h. Referenced by SlamSelfLocator::motionUpdate(), SlamSelfLocator::updateByFlag(), SlamSelfLocator::updateByGoalPost(), and SlamSelfLocator::updateByNotSeenGoal().

double SlamSelfLocatorSample::perceptProbabilities[numberOfPerceptTypes]

| a probability for each percept-type recognized Definition at line 44 of file SlamSelfLocatorSample.h. Referenced by SlamSelfLocator::calcAveragePerceptTypeProbabilities().

long SlamSelfLocatorSample::perceptTimestamps[numberOfPerceptTypes]

| Definition at line 45 of file SlamSelfLocatorSample.h.

SlamSelfLocatorSample* SlamSelfLocatorSample::next

| The next sample in the cell cube. Definition at line 46 of file SlamSelfLocatorSample.h. Referenced by SlamSelfLocator::calcPose(), and SlamSelfLocator::calcPoseFromSubCube().

The documentation for this class was generated from the following files:

- Modules/SelfLocator/SlamSelfLocator/SlamSelfLocatorSample.h
- Modules/SelfLocator/SlamSelfLocator/SlamSelfLocatorSample.cpp